net.sf.saxon.pattern

## Class NodeKindTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.NodeKindTest

- All Implemented Interfaces:
    Serializable, ItemType

      public class NodeKindTest
      extends NodeTest

  NodeTest is an interface that enables a test of whether a node has a particular name and kind. A NodeKindTest matches the node kind only.
  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static NodeKindTest` | `ATTRIBUTE`
    `static NodeKindTest` | `COMMENT`
    `static NodeKindTest` | `DOCUMENT`
    `static NodeKindTest` | `ELEMENT`
    `static NodeKindTest` | `NAMESPACE`
    `static NodeKindTest` | `PROCESSING_INSTRUCTION`
    `static NodeKindTest` | `TEXT`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object other)` Indicates whether some other object is "equal to" this one.
    `AtomicType` | `getAtomizedItemType()` Get the content type allowed by this NodeTest (that is, the type annotation).
    `SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type of content allowed).
    `double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
    `int` | `getNodeKind()` Get the node kind matched by this test
    `int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
    `int` | `getPrimitiveType()` Determine the types of nodes to which this pattern applies.
    `int` | `hashCode()` Returns a hash code value for the object.
    `static NodeTest` | `makeNodeKindTest(int kind)` Make a test for a given kind of node
    `boolean` | `matches(int nodeKind, NodeName name, int annotation)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
    `static String` | `nodeKindName(int kind)` Get the name of a node kind
    `String` | `toString()`
    `static String` | `toString(int kind)`

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `getFingerprint, getPrimitiveItemType, getRequiredNodeNames, getSuperType, isAtomicType, isAtomizable, isNillable, isPlainType, matches, matchesItem, visitNamedSchemaComponents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DOCUMENT

          public static final NodeKindTest DOCUMENT

    - #### ELEMENT

          public static final NodeKindTest ELEMENT

    - #### ATTRIBUTE

          public static final NodeKindTest ATTRIBUTE

    - #### TEXT

          public static final NodeKindTest TEXT

    - #### COMMENT

          public static final NodeKindTest COMMENT

    - #### PROCESSING_INSTRUCTION

          public static final NodeKindTest PROCESSING_INSTRUCTION

    - #### NAMESPACE

          public static final NodeKindTest NAMESPACE

  - ### Method Detail

    - #### getNodeKind

          public int getNodeKind()

      Get the node kind matched by this test
      Returns:
        the matching node kind

    - #### makeNodeKindTest

          public static NodeTest makeNodeKindTest(int kind)

      Make a test for a given kind of node

    - #### matches

          public boolean matches(int nodeKind,
                        NodeName name,
                        int annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node tst

    - #### matches

          public boolean matches(TinyTree tree,
                        int nodeNr)

      Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `tree` - the TinyTree containing the node
        `nodeNr` - the number of the node within the TinyTree
      Returns:
        true if the node matches the NodeTest, otherwise false

    - #### matches

          public boolean matches(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Returns:
        the default priority

    - #### getPrimitiveType

          public int getPrimitiveType()

      Determine the types of nodes to which this pattern applies. Used for optimisation.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

    - #### getNodeKindMask

          public int getNodeKindMask()

      Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<
      Overrides:
        `getNodeKindMask` in class `NodeTest`
      Returns:
        a combination of bits: 1<

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type of content allowed). Return AnyType if there are no restrictions.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Get the content type allowed by this NodeTest (that is, the type annotation). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `NodeTest`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### toString

          public static String toString(int kind)

    - #### nodeKindName

          public static String nodeKindName(int kind)

      Get the name of a node kind
      Parameters:
        `kind` - the node kind, for example Type.ELEMENT or Type.ATTRIBUTE
      Returns:
        the name of the node kind, for example "element" or "attribute"

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object other)

      Indicates whether some other object is "equal to" this one.
      Overrides:
        `equals` in class `Object`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.